package ${basePackage}.module.system.ent;

import ${basePackage}.frame.base.BaseEntity;
import ${basePackage}.frame.excel.annotation.ColumnDescription;
import ${basePackage}.frame.excel.annotation.ColumnName;
import ${basePackage}.frame.excel.annotation.SheetName;

/**
 * DICT_ITEM - 字典项
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2019-07-20
 */
@SheetName("字典项")
public class DictItem extends BaseEntity {

    /**
     * DICT_ID - 字典ID
     */
    @ColumnName("字典主键")
    @ColumnDescription("字典主键一般为一窜数字，可通过字典查询页获取字典主键")
    private Long dictId;
    /**
     * KEY - 字典KEY
     */
    @ColumnName("字典键")
    @ColumnDescription("字典键一般使用数字或字母 01,02... A,B...")
    private String key;
    /**
     * VALUE - 字典VALUE
     */
    @ColumnName("字典值")
    @ColumnDescription("字典值一般是实际意思字符或文字\n 长度在(1-100)之间")
    private String value;
    /**
     * SORT - 排序
     */
    @ColumnName("字典排序值")
    @ColumnDescription("用于标识字典值排列顺序、必须为数字")
    private Integer sort;
    /**
     * VALID - 是否有效
     */
    @ColumnName("是否有效")
    @ColumnDescription("用于标识该字典值是否有效")
    private Boolean valid;

    public Long getDictId() {
        return this.dictId;
    }

    public void setDictId(Long dictId) {
        this.dictId = dictId;
    }

    public String getKey() {
        return this.key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getValue() {
        return this.value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public Integer getSort() {
        return this.sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public Boolean getValid() {
        return this.valid;
    }

    public void setValid(Boolean valid) {
        this.valid = valid;
    }
}